//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}


int main()
{
  vector<int> coll1;
  deque<int> coll2;

  INSERT_ELEMENTS(coll1,1,9);
  INSERT_ELEMENTS(coll2,11,23);

  PRINT_ELEMENTS(coll1,"1- :\n");
  PRINT_ELEMENTS(coll2,"2- :\n");

  //  coll1      coll2
  deque<int>::iterator pos;
  pos = swap_ranges (coll1.begin(), coll1.end(),  //  
                     coll2.begin());              //  

  PRINT_ELEMENTS(coll1,"\n1- :\n");
  PRINT_ELEMENTS(coll2,"2- :\n");
  if (pos != coll2.end()) {
      cout << ToRus("  : ")
           << *pos << endl;
  }

  //      coll2
  //    
  swap_ranges (coll2.begin(), coll2.begin()+3,    //  
               coll2.rbegin());                   //  

  PRINT_ELEMENTS(coll2,"\n2- :\n");


  getch();
  return 0;
}

//---------------------------------------------------------------------------